#include <stdio.h>
#include <stdlib.h>
#include "global.h" 
#include "functions.h" 
#include "util.h" 
#include "plist.h"

void add_point_to_mesh(POINT *point, POINT *parent, int timeslice){
  int i;

  if(Trace){
    our_printf("entered add_point_to_mesh()\n");
    ++Trace_level;
  }

  if(parent){
    ++parent->children;
  }

  point->g_partial = 0; 
  if(timeslice > 0){ 
    /* calculate g_partial for this new point */
    for(i=0; i<Time[timeslice-1].elements; i++){ 
      point->g_partial += Time[timeslice-1].element[i].children*
        transition_probability(&(Time[timeslice-1].element[i]), point); 

    } 
  
    /* update g_partials for other points on timeslice */
    for(i=0; i< Time[timeslice].elements; i++){ 
      Time[timeslice].element[i].g_partial += transition_probability(parent,
                                                                     &(Time[timeslice].element[i]));
    } 
  }  

  point->date = timeslice*(Expiration/(Timeslices-1)); 
  find_important_points(point, timeslice);
  point->children           = 0;
  point->value_if_exercised = payoff(point, timeslice); 
  plist_append(&(Time[timeslice]),point);

  /* Append to list of important points as the index of the last added
     point at t+1 */
  if(parent){
    ilist_append(&(parent->important_point), Time[timeslice].elements - 1) ;
  }

  if(Trace){
    --Trace_level;
    our_printf("exiting add_point_to_mesh()\n");
  }
}
