#include <stdlib.h>
#include <stdio.h>
#include "data_structure.h"
#include "global.h"
#include "functions.h"

int allocate_point(POINT *point){

  if(Trace){
    our_printf("entered allocate_point()\n");
    ++Trace_level;
  }

  point->price = (double*)calloc(Dimensions,sizeof(double));
  if(point->price == NULL){
    fprintf(stderr, "Error: allocate_point was unable to get memory.\n");
    return(-1);
  }

  if(ilist_allocate(&(point->important_point))){
    fprintf(stderr, "ilist_allocate(&(point->important_point) had an error.\n");
    return(-1);
  }

  if(dlist_allocate(&(point->exact_control))){
    fprintf(stderr, "Error: in allocate_point:\n");
    fprintf(stderr, "dlist_allocate(&(point->exact_control) had an error.\n");
    return(-1);
  }

  if(dlist_allocate(&(point->estimated_control))){
    fprintf(stderr, "Error: in allocate_point:\n");
    fprintf(stderr, "dlist_allocate(&(point->estimated_control) had an error.\n");
    return(-1);
  }

  if(Trace){
    --Trace_level;
    our_printf("exiting allocate_point()\n");
  }

  return(0);
}

int deallocate_point(POINT *point){
  free(point->price);
  ilist_deallocate(&(point->important_point));
  dlist_deallocate(&(point->exact_control));
  dlist_deallocate(&(point->estimated_control));
  return(0);
}

