#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "plist.h"

void columbia(){
  int timeslice, i,*tmp;
  POINT *point;


  tmp = (int *)malloc(sizeof(int) * Columbia_paths);

  for(i=0; i< Columbia_paths; i++)tmp[i] = i;

  printf("Number of Timeslices = %d\n", Timeslices);

  for(timeslice = Timeslices-2; timeslice>=0 ; timeslice--){

    printf("*******> time = %d of %d\n", timeslice, Timeslices-1);
    printf("  number of elements at t+1= %d\n", Time[timeslice+1].elements);

    /* Loop over all the points at the current time and compute estimates */
    for(i = 0; i< Time[timeslice].elements; i++){

      /* Extract the pointer to an element */
      point = &(Time[timeslice].element[i]);


      /* update important points */

      /* 1. Clean up current important points list */
      ilist_finalize(&(point->important_point));

      /* 2. Set the important_point list to include all points at future*/
      point->important_point.elements = Time[timeslice+1].elements;
      point->important_point.size = Time[timeslice+1].elements;
      point->important_point.element = tmp;

      /* Now recompute all estimates using all points 
         Are all g_partial's corrected computed at this point? */

      point->value_if_exercised = payoff(point, timeslice);
      point->value_if_held      = mesh_estimate_value(point, 
                                    timeslice,&(point->error));
      point->value              = dMax(point->value_if_held, 
                                    point->value_if_exercised);
      point->delta_r            = point->value_if_exercised - 
                                    point->value_if_held;
/*
      printf("Address check %x %x \n", point, &(Time[timeslice].element[i]));
*/
    }
  }
  free(tmp);
}

