#include <stdio.h>
#include <stdlib.h>
#include "dlist.h"


int dlist_allocate(DLIST **dlist){
  *dlist = (DLIST *)malloc(sizeof(DLIST) );
  if(*dlist == NULL) return(-1);
  return(0);
}


int dlist_initialize(DLIST *dlist){
  dlist->element = NULL;
  dlist->elements = 0;
  dlist->size = 0;
  return(0);
}


int dlist_finalize(DLIST *dlist){
  if(dlist->element) free(dlist->element);
  return(0);
}


int dlist_deallocate(DLIST *dlist){
  free(dlist);
  return(0);
}


int dlist_copy(DLIST *from, DLIST *to){
  int i, error_code=0;

  error_code += dlist_finalize(to);
  error_code += dlist_initialize(to);
  for(i=0; i<from->elements; ++i){
    error_code += dlist_append(to, from->element[i]);
  }
  return(error_code);
}


DLIST *dlist_clone(DLIST *from){
  int i;
  DLIST *to;

  dlist_allocate(&to);
  dlist_initialize(to);
  for(i=0; i<from->elements; ++i){
    dlist_append(to, from->element[i]);
  }
  return(to);
}
  

int dlist_extend(DLIST *dlist){
  if(dlist->size == 0){
    dlist->size = DLIST_EXTENSION;
    dlist->element = (double *)malloc(dlist->size*sizeof(double));
  }else{
    dlist->size += DLIST_EXTENSION; 
    dlist->element = (double *)realloc(dlist->element,sizeof(double)*dlist->size);
  }
  if(dlist->element == NULL) return(-1);
  return(0);
}


int dlist_append(DLIST *dlist, double value){
  int error_code;

  if(dlist->elements ==  dlist->size){
    error_code = dlist_extend(dlist);
    if(error_code) return(-1);
  }

  dlist->elements++;
  dlist->element[dlist->elements - 1] = value;
  return(0);
}

