/* A list of doubles which can be appended to and automatically allocates
 * memory.
 * 
 * DLIST.element[i]          The i'th element in the list
 * DLIST.elements            The number of elements in the list 
 * DLIST.size                The amount of memory (in elements) allocated
 */


#ifndef DLIST_EXTENSION
#define DLIST_EXTENSION 20
#endif

#ifndef DLIST_STRUCTURE
typedef struct{
  double *element;
  int elements;
  int size;
} DLIST;
#define DLIST_STRUCTURE
#endif


#ifndef DLIST_FUNCTIONS
int dlist_allocate(DLIST **dlist);
int dlist_deallocate(DLIST *dlist);
int dlist_initialize(DLIST *dlist);
int dlist_finalize(DLIST *dlist);
int dlist_copy(DLIST *from, DLIST *to);
DLIST *dlist_clone(DLIST *from);
int dlist_extend(DLIST *dlist);
int dlist_append(DLIST *dlist, double value);
#define DLIST_FUNCTIONS
#endif
