#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "util.h"

char string[1024];

int error_too_large(POINT *point, int timeslice){
  int result;
  if(Trace){
    our_printf("entering error_too_large()\n");
    ++Trace_level;
  }

  switch(Simulation_type){
  case(0):
    /* Columbia emulation version */
    if(timeslice == 0){
      if(point->important_point.elements == Columbia_paths) return(0);
      result = 1;
    }
    
    if (point->children == 1) return(0);
    result = 1;
    break;
  default:
    /* Tree and Columbia */
    if(Trace){
      sprintf(string,"%i  %lf +/- %lf (%lf rel) of %lf\n",point->important_point.elements, point->value, point->error, point->error/point->value,fabs(point->delta_r)*Error_target);
      our_printf(string);
    }
    if(point->important_point.elements < 4){
      result = 1;
    }else if(point->error/point->value < Error_floor){
      result = 0;
    }else if(point->error/point->value > Error_ceiling){
      result = 1;
    }else if(point->error > Error_target*fabs(point->delta_r)){
      result = 1;
    }else{
      result = 0;
    }
    break;
  }
  
  if(Trace){
    --Trace_level;
    our_printf("exiting error_too_large()\n");
  }
  return(result);
}
        
        
        
