#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "ranlib.h"

/* 
 Routine checked against mesh2 code to be correct. 
 Produces identical results 
*/
void grow_point(double *initial_price, double *final_price){
  int underlier;
  static double *growth = NULL;

  if(growth == NULL){
     allocate1dDouble(&growth,Dimensions);
  }

  genmn(Parm, growth, Cov1);

  for(underlier=0; underlier<Dimensions; ++underlier){
    final_price[underlier] = exp(growth[underlier]-Covariance[underlier][underlier]/2)*initial_price[underlier];
  }
}

