#include <stdio.h>
#include <stdlib.h>
#include "ilist.h"


int ilist_allocate(ILIST **ilist){
  *ilist = (ILIST *)malloc(sizeof(ILIST) );
  if(*ilist == NULL) return(-1);
  return(0);
}


int ilist_initialize(ILIST *ilist){
  ilist->element = NULL;
  ilist->elements = 0;
  ilist->size = 0;
  return(0);
}


int ilist_finalize(ILIST *ilist){
  if(ilist->element) free(ilist->element);
  return(0);
}


int ilist_deallocate(ILIST *ilist){
  free(ilist);
  return(0);
}


int ilist_copy(ILIST *from, ILIST *to){
  int i, error_code=0;

  error_code += ilist_finalize(to);
  error_code += ilist_initialize(to);
  for(i=0; i<from->elements; ++i){
    error_code += ilist_append(to, from->element[i]);
  }
  return(error_code);
}


ILIST *ilist_clone(ILIST *from){
  int i;
  ILIST *to;

  ilist_allocate(&to);
  ilist_initialize(to);
  for(i=0; i<from->elements; ++i){
    ilist_append(to, from->element[i]);
  }
  return(to);
}
  

int ilist_extend(ILIST *ilist){
  if(ilist->size == 0){
    ilist->size = ILIST_EXTENSION;
    ilist->element = (int*)malloc(ilist->size*sizeof(int));
  }else{
    ilist->size += ILIST_EXTENSION; 
    ilist->element = (int *)realloc(ilist->element,sizeof(int)*ilist->size);
  }
  if(ilist->element == NULL) return(-1);
  return(0);
}


int ilist_append(ILIST *ilist, int value){
  int error_code;

  if(ilist->elements ==  ilist->size){
    error_code = ilist_extend(ilist);
    if(error_code) return(error_code);
  }

  ilist->elements++;
  ilist->element[ilist->elements - 1] = value;
  return(0);
}




