/* A list of integers which can be appended to and automatically allocates
 * memory.
 * 
 * ILIST.element[i]          The i'th element in the list
 * ILIST.elements            The number of elements in the list 
 * ILIST.size                The amount of memory (in elements) allocated
 */


#ifndef ILIST_EXTENSION
#define ILIST_EXTENSION 20
#endif

#ifndef ILIST_STRUCTURE
typedef struct{
  int *element;
  int elements;
  int size;
} ILIST;
#define ILIST_STRUCTURE
#endif


#ifndef ILIST_FUNCTIONS
int ilist_allocate(ILIST **ilist);
int ilist_deallocate(ILIST *ilist);
int ilist_initialize(ILIST *ilist);
int ilist_finalize(ILIST *ilist);
int ilist_copy(ILIST *from, ILIST *to);
ILIST *ilist_clone(ILIST *from);
int ilist_extend(ILIST *ilist);
int ilist_append(ILIST *ilist, int value);
#define ILIST_FUNCTIONS
#endif

