#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "ranlib.h"
#include "our_getopt.h"

/* Global variables from our_getopt.c */
extern char *optarg;
extern int optind;


void init_rng(void){
  int i,j,k;
  long seed1, seed2;

  if(Trace){
    our_printf("entered init_rng()\n");
    ++Trace_level;
  }

  allocate1dDouble(&Cov1,Dimensions*Dimensions);
  allocate1dDouble(&Parm,Dimensions*(Dimensions+3)/2+1);

  /* Copy the 2d covariance matrix into the 1d scratch matrix */
  k = 0;
  for(i=0; i<Dimensions; i++){
    for(j=0; j<Dimensions; j++){
      Cov1[k] = Covariance[i][j];
      k++;
    }
  }
  
  /* Give the data to RANLIB and let it do what it wants in parm */
  setgmn(Dividend_adjusted_mean, Cov1, Dimensions, Parm);

  /* Hash the phrase into RNG seeds */
  phrtsd("Get Rich Quick!", &seed1, &seed2);

  /* Initialize the RNG with the seeds */
  setall(seed1, seed2);

  if(Trace){
    --Trace_level;
    our_printf("exiting init_rng()\n");
  }


}


