#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "ranlib.h"
#include "our_getopt.h"
#include "plist.h"

int main(int argc, char *argv[]){
  int i,j, count;
  POINT initial_point ;

  handle_command_line(argc,argv);

  if(Trace){
    Trace_file_handle = fopen(Trace_file,"a");
    our_printf("entered main()\n");
    ++Trace_level;
  }

  init_rng();

  allocate1dPLIST(&Time,Timeslices);

  point_initialize(&initial_point);
  for(i=0; i<Dimensions; i++) initial_point.price[i] = Initial_price;

  add_point_to_mesh(&initial_point, NULL, 0);
  value(&(Time[0].element[0]),0);

  if(Simulation_type == 0){
    printf("Before columbia correction: %lf +/- %lf\n",Time[0].element[0].value,Time[0].element[0].error);
    columbia();
    printf("The option value is: %lf +/- %lf\n",Time[0].element[0].value,Time[0].element[0].error);
  }else{
    printf("Option value is %lf +/- %lf\n",Time[0].element[0].value,Time[0].element[0].error);
  }

  if(Trace){
    --Trace_level;
    our_printf("exiting main()\n");
  }

  return(0);
}
