#include <stdio.h>
#include <stdlib.h>
#include "plist.h"


int plist_allocate(PLIST **plist){
  *plist = (PLIST *)malloc(sizeof(PLIST) );
  if(*plist == NULL) return(-1);
  return(0);
}


int plist_initialize(PLIST *plist){
  plist->element = NULL;
  plist->elements = 0;
  plist->size = 0;
  return(0);
}


int plist_finalize(PLIST *plist){
  if(plist->element) free(plist->element);
  return(0);
}


int plist_deallocate(PLIST *plist){
  free(plist);
  return(0);
}


int plist_copy(PLIST *from, PLIST *to){
  int i, error_code = 0;

  error_code += plist_finalize(to);
  error_code += plist_initialize(to);
  for(i=0; i<from->elements;i++){
    error_code += plist_append(to,&(from->element[i]));
  }
  return(error_code);
}


PLIST *plist_clone(PLIST *from){
  int i;
  PLIST *to;

  plist_allocate(&to);
  plist_initialize(to);
  for(i=0; i<from->elements; i++){
    plist_append(to, &(from->element[i]));
  }
  return(to);
}


int plist_extend(PLIST *plist){
  if(plist->size == 0){
    plist->size = PLIST_EXTENSION;
    plist->element = (POINT *)malloc(sizeof(POINT)*plist->size);
  }else{
    plist->size += PLIST_EXTENSION; 
    plist->element = (POINT *)realloc(plist->element,sizeof(POINT)*plist->size);
  }
  if(plist->element == NULL) return(-1);
  return(0);
}


int plist_append(PLIST *plist, POINT *value){
  int error_code;

  if(plist->elements ==  plist->size){
    error_code = plist_extend(plist);
    if(error_code) return(-1);
  }

  plist->elements++;
  point_initialize(&(plist->element[plist->elements - 1]));
  point_copy(value, &(plist->element[plist->elements - 1]));
  return(0);
}
