/* A list of POINTs which can be appended to and automatically allocates
 * memory.
 * 
 * PLIST.element[i]          The i'th element in the list
 * PLIST.elements            The number of elements in the list 
 * PLIST.size                The amount of memory (in elements) allocated
 */


#ifndef PLIST_EXTENSION
#define PLIST_EXTENSION 20
#endif

#ifndef POINT_STRUCTURE
#include "point.h"
#endif

#ifndef POINT_FUNCTIONS
#include "point.h"
#endif

#ifndef PLIST_STRUCTURE
typedef struct{
  POINT *element;
  int elements;
  int size;
} PLIST;
#define PLIST_STRUCTURE
#endif

#ifndef PLIST_FUNCTIONS
int plist_extend(PLIST *plist);
int plist_allocate(PLIST **plist);
int plist_deallocate(PLIST *plist);
int plist_initialize(PLIST *plist);
int plist_finalize(PLIST *plist);
int plist_copy(PLIST *from, PLIST *to);
int plist_append(PLIST *plist, POINT *value);
#define PLIST_FUNCTIONS
#endif

