#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "plist.h"

int point_is_relevant(POINT *from, POINT *to){
  double european, tp,w,f;
  int max,result;

  switch(Simulation_type){
  case(0):
    /* Columbia */
    result = 1;
    break;
  case(1):
    /* Tree */
    result = 0;
    break;
  default:
    /* NPAC */
    max = dWhichMax(Dimensions,from->price);
    european = euroCall(from->price[max],Strike_price,Interest_rate,sqrt(Covariance[max][max]),
                        Expiration-from->date,
                        Dividend_rate[max]);
    tp = transition_probability(from,to);
    w = tp/to->g_partial;
    f = to->value;
    if( w*f/european < Relevance_cutoff){
      result = 0;
    }else{
      result = 1;
    }
    break;
  }
  return(result);
}
