#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "plist.h"

double transition_probability(POINT *from, POINT *to){
  int underlier;
  double constant=-1, exponential, growth;

  if(constant == -1){
    constant = pow(2*3.14159265359,Dimensions);
    for(underlier=0; underlier<Dimensions; underlier++){
      constant *= Covariance[underlier][underlier];
    }
    constant = 1.0/sqrt(constant);
  }

  exponential = 0;
  for(underlier=0; underlier<Dimensions; underlier++){
    growth = log(to->price[underlier]/from->price[underlier]) + Covariance[underlier][underlier]/2;
    exponential += (growth - Dividend_adjusted_mean[underlier])* (growth - Dividend_adjusted_mean[underlier])/Covariance[underlier][underlier];
  }
  exponential = exp(-0.5*exponential);

  return(constant*exponential);
}
