#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "plist.h"

void value(POINT *point, int timeslice){
  POINT scratch_point;

  if(Trace){
    our_printf("entered value()\n");
    ++Trace_level;
  }
  
  if(timeslice == Timeslices-1){ 
    point->value_if_held = 0;
    point->value_if_exercised = payoff(point,timeslice);
    point->value              = dMax(point->value_if_held, point->value_if_exercised);
    point->error = 0;
    point->delta_r            = point->value_if_exercised - point->value_if_held;
  }else{
  


    /* if the error is too large at this time add point */
    while(error_too_large(point, timeslice)){
      point_initialize(&scratch_point);
      grow_point(point->price, scratch_point.price);
      add_point_to_mesh(&scratch_point, point, timeslice+1);

      /* the new point is now the last point in the next timeslice */
      value( &(Time[timeslice+1].element[ Time[timeslice+1].elements-1 ]), timeslice+1);

      point->value_if_exercised = payoff(point, timeslice);
      point->value_if_held      = dMax(0,mesh_estimate_value(point, timeslice,&(point->error)));
      point->value              = dMax(point->value_if_held, point->value_if_exercised);
      point->delta_r            = point->value_if_exercised - point->value_if_held;
      point_finalize(&scratch_point);
    }
  }
  if(Trace){
    --Trace_level;
    our_printf("exiting value()\n");
  }
}      
    
